module JenkinsJob
  module Postbuild
    class PostbuildSlack < BasicObject
      attr_reader :base_url_, :auth_token_, :start_notification_, :notify_success_, :notify_aborted_,
                  :notify_not_built_, :notify_unstable_, :notify_regression_, :notify_failure_,
                  :notify_back_to_normal_, :notify_repeated_failure_, :include_test_summary_,
                  :include_failed_tests_

      def initialize
        @start_notification_ = false
        @notify_success_ = false
        @notify_aborted_ = false
        @notify_not_built_ = false
        @notify_unstable_ = false
        @notify_regression_ = false
        @notify_failure_ = false
        @notify_back_to_normal_ = false
        @notify_repeated_failure_ = false
        @include_test_summary_ = false
        @include_failed_tests_ = false
      end

      def base_url(value)
        @base_url_ = value
      end

      def auth_token(value)
        @auth_token_ = value
      end

      def start_notification(value = false)
        @start_notification_ = value
      end

      def notify_success(value = false)
        @notify_success_ = value
      end

      def notify_aborted(value = false)
        @notify_aborted_ = value
      end

      def notify_not_built(value = false)
        @notify_not_built_ = value
      end

      def notify_unstable(value = false)
        @notify_unstable_ = value
      end

      def notify_regression(value = false)
        @notify_regression_ = value
      end

      def notify_failure(value = false)
        @notify_failure_ = value
      end

      def notify_back_to_normal(value = false)
        @notify_back_to_normal_ = value
      end

      def notify_repeated_failure(value = false)
        @notify_repeated_failure_ = value
      end

      def include_test_summary(value = false)
        @include_test_summary_ = value
      end

      def include_failed_tests(value = false)
        @include_failed_tests_ = value
      end
    end
  end
end
