require_relative '../lib/rubyjobbuilderdsl'

builder = JenkinsJob::Builder.new

builder.pipeline 'hello_world-post' do
  timed '0 4 * * 1-5'
  postbuild do
    publish_slack do
      base_url 'This is base url'
      auth_token 'This is an auth_token'
      start_notification true
      notify_success true
      notify_aborted true
      notify_failure true
    end
  end
  groovy <<EOS
build("hello_world",
    SOME_PARAM: "A_param_value")
EOS
end

JenkinsJob::Deployer.new(builder).run
